-- functions
function CleanUI_OnLoad(self)
    
    CleanUI_InitDefaultSettings();
    
    -- remove 'Created by'
    -- remove Socketable
    ITEM_CREATED_BY = "";
    ITEM_SOCKETABLE = "";
    
    -- hook methods
    hooksecurefunc(StaticPopupDialogs["DELETE_GOOD_ITEM"], "OnShow", function(s) s.editBox:SetText(DELETE_ITEM_CONFIRM_STRING.."?"); end); 
    hooksecurefunc("GameMenuFrame_UpdateVisibleButtons", CleanUI_GameMenuFrame_UpdateVisibleButtons);

    -- flash Mac-OSX Dock icon or Windows-Taskbar icon
    hooksecurefunc("StaticPopup_Show", FlashClientIcon);

    -- fix for 'forbidden' message popup
    hooksecurefunc("StaticPopup_Show", function(which)
        if(which == "ADDON_ACTION_FORBIDDEN") then
            StaticPopup_Hide(which);
        end
    end);
    
    -- events
    self:RegisterEvent("PLAYER_ENTERING_WORLD");
    --self:RegisterEvent("ADDON_LOADED");
    --self:RegisterEvent("CVAR_UPDATE");
    self:RegisterEvent("READY_CHECK");
    self:RegisterEvent("PLAYER_MONEY");
    self:RegisterEvent("PLAYER_LEVEL_UP");
    
    self:RegisterEvent("TALKINGHEAD_REQUESTED");
    
    -- temp fixes
    SetCVar("floatingCombatTextCombatHealing", 1);
    SetCVar("floatingCombatTextCombatDamage", 1);
    
    SetCVar("nameplateMaxDistance", 40);
    SetCVar("nameplateOtherTopInset", -1);
    SetCVar("nameplateOtherBottomInset", -1);
    
    -- nameplate fix
    C_NamePlate.SetNamePlateSelfClickThrough(true);
    
    -- camera fix
    --SetCVar("cameraDistanceMaxFactor", 2.6);
    
    -- frame position fix
    --WorldQuestCompleteAlertFrame:ClearAllPoints();
    --WorldQuestCompleteAlertFrame:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, 200);
    
    -- chat commands
    CleanUI_InitSlashCommandHandler();
    CleanUI_InitCommon()
    
    -- MouseFixes
    DeathKnightResourceOverlayFrame:EnableMouse(false);
    for i = 1, #DeathKnightResourceOverlayFrame.Runes do
        DeathKnightResourceOverlayFrame.Runes[i]:EnableMouse(false);
    end
    
    ClassNameplateBarMageFrame:EnableMouse(false);
    for i = 1, #ClassNameplateBarMageFrame.Charges do
        ClassNameplateBarMageFrame.Charges[i]:EnableMouse(false);
    end
    
    ClassNameplateBarWindwalkerMonkFrame:EnableMouse(false);
    for i = 1, #ClassNameplateBarWindwalkerMonkFrame.Chi do
        ClassNameplateBarWindwalkerMonkFrame.Chi[i]:EnableMouse(false);
    end
    
    ClassNameplateBarPaladinFrame:EnableMouse(false);
    for i = 1, #ClassNameplateBarPaladinFrame.Runes do
        ClassNameplateBarPaladinFrame.Runes[i]:EnableMouse(false);
    end
    
    ClassNameplateBarRogueDruidFrame:EnableMouse(false);
    for i = 1, #ClassNameplateBarRogueDruidFrame.ComboPoints do
        ClassNameplateBarRogueDruidFrame.ComboPoints[i]:EnableMouse(false);
    end
    
    ClassNameplateBarWarlockFrame:EnableMouse(false);
    for i = 1, #ClassNameplateBarWarlockFrame.Shards do
        ClassNameplateBarWarlockFrame.Shards[i]:EnableMouse(false);
    end
    
    ClassNameplateBarWarlockFrame:EnableMouse(false);
    for i = 1, #ClassNameplateBarWarlockFrame.Shards do
        ClassNameplateBarWarlockFrame.Shards[i]:EnableMouse(false);
    end
    
end

function CleanUI_InitDefaultSettings()
    -- per account data
    CleanUISavedVariables = CleanUISavedVariables or {};
    CleanUIAccountData = CleanUIAccountData or {};
    CleanUICurrency = CleanUICurrency or {};
    
    -- per char data
    CleanUserData = CleanUserData or {};
    CleanUIContainerLock = CleanUIContainerLock or {};
    
    -- ActionCam
    CleanUISavedVariables.ActionCam = CleanUISavedVariables.ActionCam or "basic";
    CleanUI_StartDelay(3, function(msg)
        ConsoleExec("ActionCam "..CleanUISavedVariables.ActionCam);
    end); 
    
    -- Item buttons
    if (CleanUISavedVariables.ItemButtons == nil) then
        CleanUISavedVariables.ItemButtons = true;
    end
end

function CleanUI_InitSlashCommandHandler()

    SLASH_CLEANUI1 = "/cui";
    SLASH_CLEANUI2 = "/cleanui";
    SlashCmdList["CLEANUI"] = function(msg)
        CleanUI_SlashCommandHandler(msg);
    end
end

function CleanUI_SlashCommandHandler(msg)
    if (msg == "reload") then
        ReloadUI();
    elseif (msg == "reset") then
        CleanUI_ResetSettings();
    elseif (msg == "gc") then
        CleanUI_GC();
    elseif (msg == "build") then
        CleanUI_WoWBuildInfo();
    elseif (msg == "toggle ItemButtons") then
        CleanUISavedVariables.ItemButtons = not CleanUISavedVariables.ItemButtons;
        if (CleanUISavedVariables.ItemButtons) then
            cui_info("ItemButtons enabled");
        else
            cui_info("ItemButtons disabled");
        end
    elseif (string.find(msg, "scale UnitFrames") == 1) then
        local str_scale = string.sub(msg, 18);
        local scale = tonumber(str_scale);
        CleanUI_SetUnitFramesScale(scale);
    elseif (string.find(msg, "dragon") == 1) then
        local str_id = string.sub(msg, 8);
        local id = tonumber(str_id);
        CleanUI_SetUnitFrameDragon(id);
    elseif (string.find(msg, "scale PartyFrames") == 1) then
        local str_scale = string.sub(msg, 19);
        local scale = tonumber(str_scale);
        CleanUI_SetPartyScale(scale);
    elseif (string.find(msg, "scale MiniMap") == 1) then
        local str_scale = string.sub(msg, 15);
        local scale = tonumber(str_scale);
        CleanUI_SetMiniMapScale(scale);
    elseif (string.find(msg, "scale ActionBars") == 1) then
        local str_scale = string.sub(msg, 18);
        local scale = tonumber(str_scale);
        CleanUI_SetActionBarsScale(scale);
    elseif (string.find(msg, "toggle cursor") == 1) then
        if (CleanUISavedVariables.noCursorFlash) then
            CleanUISavedVariables.noCursorFlash = false;
        else
            CleanUISavedVariables.noCursorFlash = true;
        end
    elseif (string.find(msg, "ActionCam") == 1) then
        local str_index = string.sub(msg, 11);
        local index = tonumber(str_index);
        CleanUI_SetActionCamMode(index);
    elseif (msg == "reset money") then
        CleanUI_ResetMoney();
    else
        CleanUI_ShowInfo()
    end
end

function CleanUI_ShowInfo()
    DEFAULT_CHAT_FRAME:AddMessage("|c333399ff==================|r", 1.0, 1.0, 1.0, 1, 10);
    cui_info("chat commands:")
    cui_info("/cui reload", "reload ui")
    cui_info("/cui reset", "reset CleanUI")
    cui_info("/cui gc", "run blizz garbage colletion")
    cui_info("/cui build", "show wow build info")
    cui_info("/cui scale UnitFrames #", "scale unit frames")
    cui_info("/cui scale PartyFrames #", "scale party unit frames")
    cui_info("/cui scale MiniMap #", "scale mini map")
    cui_info("/cui scale ActionBars #", "scale action buttons")
    cui_info("/cui toggle ItemButtons", "enable/disable item buttons")
    cui_info("/cui toggle cursor", "enable/disable cursor flash")
    cui_info("/cui dragon #", "dragon style 0 - 4")
    cui_info("/cui ActionCam #", "Action cam mode 0 - 4 (0 = off, 1 = default, 2 = basic, 3 = full)")
    cui_info("/cui reset money", "reset saved money")
    DEFAULT_CHAT_FRAME:AddMessage("|c333399ff==================|r", 1.0, 1.0, 1.0, 1, 10);
end

function CleanUI_ResetSettings()
    CleanUI_SetUnitFramesScale(1.2);
    CleanUI_SetMiniMapScale(1.1);
    CleanUI_SetActionBarsScale(1.0);
    CleanUI_SetActionCamMode(2);
end

function CleanUI_SetActionCamMode(index)
    if (index == 0) then
        CleanUISavedVariables.ActionCam = "off";
        cui_info("ActionCam disabled");
    elseif (index == 1) then
        CleanUISavedVariables.ActionCam = "default";
        cui_info("ActionCam default enabled");
    elseif (index == 2) then
        CleanUISavedVariables.ActionCam = "basic";
        cui_info("ActionCam basic enabled");
    elseif (index == 3) then
        CleanUISavedVariables.ActionCam = "full";
        cui_info("ActionCam full enabled");
    end
    
    ConsoleExec("ActionCam "..CleanUISavedVariables.ActionCam);
end

function CleanUI_OnEvent(self, event, ...)

    --cui_debug(event, "event");

    if (event == "ADDON_LOADED") then
        local addonName = ...;
    end

    if (event == "CVAR_UPDATE") then
        local cvar, value = ...;
        cui_debug(value, cvar);
    end
    
    -- flash Mac-OSX Dock Icon or Windows-Taskbar Icon
    if (event == "READY_CHECK") then
        FlashClientIcon();
    end
    
    if (event == "PLAYER_MONEY" or event == "PLAYER_ENTERING_WORLD") then
        CleanUI_UpdateMoney();
    end
    
    if (event == "PLAYER_ENTERING_WORLD") then
        CleanUI_UpdateAccountData(); 
    end
    
    if (event == "PLAYER_LEVEL_UP") then
        CleanUI_UpdateAccountData();
    end
    
    if (event == "TALKINGHEAD_REQUESTED") then
        CleanUI_HookTalkingHead();
    end
end

local hooked = false;
function CleanUI_HookTalkingHead()
    if (hooked) then
        return;
    end
    
    if (TalkingHeadFrame) then
        TalkingHeadFrame:HookScript("OnShow", CleanUI_TalkingHeadOnShow);
        CleanUI_TalkingHeadOnShow()
    end
end

function CleanUI_TalkingHeadOnShow()
    TalkingHeadFrame:EnableMouse(false);
end

function CleanUI_InitCommon()
    local delay = 0.1;
    
    CleanUI_StartDelay(delay, CleanUI_InitCastingBars); 
    CleanUI_StartDelay(delay, CleanUI_InitActionBars); 
    CleanUI_StartDelay(delay, CleanUI_InitBags);
    CleanUI_StartDelay(delay, CleanUI_InitChat);
    CleanUI_StartDelay(delay, CleanUI_InitCharacterFrame);
    CleanUI_StartDelay(delay, CleanUI_InitEquipmentSets);
    CleanUI_StartDelay(delay, CleanUI_InitMicroButtons);
    CleanUI_StartDelay(delay, CleanUI_InitDeBuffs); 
    CleanUI_StartDelay(delay, CleanUI_InitTalents); 
    CleanUI_StartDelay(delay, CleanUI_InitMap);
    CleanUI_StartDelay(delay, CleanUI_InitMiniMap);
    CleanUI_StartDelay(delay, CleanUI_InitOrderHall);
    CleanUI_StartDelay(delay, CleanUI_InitUnitFrames);
    
    CleanUI_GameMenuFrame_UpdateVisibleButtons()
end
