local oldname = nil;

function CleanUI_InitTalents()
    CleanUI_TalentsHookEvents();
end

function CleanUI_TalentsHookEvents()
    hooksecurefunc("UnitPopup_ShowMenu", CleanUI_UnitPopup_AppendTalents);
end

function CleanUI_UnitPopup_AppendTalents(dropdownMenu, which, unit, name, userData)

    if (unit ~= "player" or UIDROPDOWNMENU_MENU_LEVEL > 1) then
        return;
    end

    if (GetNumSpecializations(nil) > 1) then
        UIDropDownMenu_AddSeparator(UIDropDownMenu_CreateInfo(), UIDROPDOWNMENU_MENU_LEVEL);

        local eq_header = UIDropDownMenu_CreateInfo();
        eq_header.text = TALENTS;
        eq_header.isNotRadio = true;
        eq_header.notCheckable = 1;
        eq_header.isTitle = true;
        UIDropDownMenu_AddButton(eq_header);

        local id, name, description, icon, background, _, primaryStat;
        for ii=1, GetNumSpecializations(nil) do
            id, name, description, icon, background, _, primaryStat = GetSpecializationInfo(ii, nil, nil, nil, UnitSex("player"));

            local info = UIDropDownMenu_CreateInfo();
            info.text = name;
            info.tooltipTitle = name;
            info.tooltipText = description;
            info.func = function(frame) CleanUI_SelectActiveSpecGroup(ii) end;

            if (ii == GetSpecialization(nil)) then
                info.checked = true;
            end

            UIDropDownMenu_AddButton(info);
        end
    end
end

function CleanUI_SelectActiveSpecGroup(index)
    SetSpecialization(index, false);
end
